function drawCars()
	for i,v in ipairs(cars) do
		if distance(v, hero) < sightRange then
			love.graphics.draw(truckImage, v.x, v.y, v.facing, 1, 1, 16, 16)
		end
	end
	
	for i,v in ipairs(wrecks) do
		if distance(v,hero) < sightRange then
			love.graphics.draw(wreckImage, v.x, v.y, v.rot)
		end
	end
	
	for i,v in ipairs(flyingCar) do
		love.graphics.draw(truckImage, v.x, v.y, v.rotation, 1, 1)
	end
	
end

function updateCars(dt)
--------SPAWNING
--	local timer = newCarTimer
	if newCarTimer > 0 then
		newCarTimer = newCarTimer - dt
	else
		generateCar()
	end	
--------------
	for i,v in ipairs(capturedCars) do
		table.remove(flyingCar, v)
		hero.score = hero.score + capValue
		table.remove(capturedCars, v)
	end
-------------
	for i,v in ipairs(flyingCar) do
		v.rotation = angle * 180 / math.pi
		if v.x > hero.x then
			v.x = v.x - beamSpeed * dt
		elseif v.x < hero.x then
			v.x = v.x + beamSpeed * dt
		end
		if v.y > hero.y then
			v.y = v.y - beamSpeed * dt
		elseif v.y < hero.y then
			v.y = v.y + beamSpeed * dt
		end
		if distance(v, hero) < ((2 * hero.width) / 3) then
			table.insert(capturedCars, i)
		end
	end
-------------
	for i,v in ipairs(cars) do
		if v.facing == math.pi/2 then
			v.y = v.y + v.speed * dt
		elseif v.facing == math.pi then 
			v.x = v.x - v.speed * dt
		elseif v.facing == ((math.pi/2) * -1) then 
			v.y = v.y - v.speed * dt
		elseif v.facing == 0 then 
			v.x = v.x + v.speed * dt
		end
		if v.x < -100 or v.x > 1380 then
			table.insert(cullCars, i)
		end
		if v.y < -100 or v.y > 868 then
			table.insert(cullCars, i)
		end
		if circleCollision(v, hero, carSightRange, hero.width) then
			wasSeen()
		end
		for ii,vv in ipairs(flyingCar) do
			if circleCollision(v, vv, carSightRange, carSightRange) then
				wasSeen()
			end
		end
	roadwork(v)
	v.turned = math.max(v.turned - dt, 0)
	end
	cull()
end


function generateCar()
	car = {}
	local dieRoll = math.random(1,5)
	local tempX, tempY
	local TW = tileWidth/2
	if dieRoll == 1 then
		tempX = 17
		tempY = 1
		car.facing = (math.pi/2)
	elseif dieRoll == 2 then
		tempX = 1
		tempY = 13
		car.facing = 0
	elseif dieRoll == 3 then
		tempX = 32
		tempY = 13
		car.facing = math.pi
	elseif dieRoll == 4 then
		tempX = 1
		tempY = 19
		car.facing = 0
	elseif dieRoll == 5 then
		tempX = 32
		tempY = 19
		car.facing = math.pi
	end
	car.x = (2*(tempX - 1) * TW) + TW
	car.y = (2*(tempY - 1) * TW) + TW
	local randomSpeed = math.random(-50,50)
	car.speed = 125 + randomSpeed
	car.turned = 0
	table.insert(cars, car)
	newCarTimer = math.random(2,5)
end


function nextSquare(vehicle, x,y)
	if level1[(vehicle.gridY/32) + y][(vehicle.gridX/32) + x] == 3 then
		return false
	else 
		return true
	end
end

function cull()
	for i,v in ipairs(cullCars) do
		table.remove(cars, v)
		table.remove(cullCars, i)
	end
end

function roadwork(veh)
	veh.gridX = math.ceil(veh.x/32)
	veh.gridY = math.ceil(veh.y/32)
	if veh.turned == 0 then
		if veh.gridX == 17 then
			if veh.gridY == 13 then
				local turn = math.random(6)
				if turn == 1 then
					turnLeft(veh)
				elseif turn == 2 then
					turnRight(veh)
				end
			elseif veh.gridY == 19 then
				local turn = math.random(6)
				if turn == 1 then
					if veh.facing == math.pi then
						turnRight(veh)
					elseif veh.facing == 0 then
						turnLeft(veh)
					elseif veh.facing == (math.pi/2) then 
						turnLeft(veh)
					end
				else
					if veh.facing == (math.pi/2) then
						turnRight(veh)
					end
				end
			end
		end
	end
end



function turnLeft(veh)
	local TW = tileWidth * 0.5
	veh.facing = veh.facing - (math.pi / 2)
	veh.x, veh.y = (2*(veh.gridX - 1) * TW) + TW, (2*(veh.gridY - 1) * TW) + TW
	veh.turned = 1
	cleanDirection(veh)
end

function turnRight(veh)
	local TW = tileWidth * 0.5
	veh.facing = veh.facing + (math.pi / 2)
	veh.x, veh.y = (2*(veh.gridX - 1) * TW) + TW, (2*(veh.gridY - 1) * TW) + TW
	veh.turned = 1
	cleanDirection(veh)
end

function cleanDirection(veh)
	if veh.facing > math.pi then
		veh.facing = veh.facing - (2 * math.pi)
	elseif veh.facing <= (math.pi * -1) then
		veh.facing = veh.facing + (2 * math.pi)
	end
end

