-- FUNCTIONS WITH BROADLY GENERAL UTILITY - MIGHT BE USEFUL ELSEWHERE LATER ON

function distance(firstObj, secondObj)
	local dx = firstObj.x - secondObj.x
	local dy = firstObj.y - secondObj.y
	dist = math.sqrt((dx ^ 2) + (dy ^ 2))
	return dist
end

function dieRoll(num, sides)
	local result = {}
	local total = 0
	for i = 1,num do
		roll = math.random(1,sides)
		table.insert(result, roll)
	end
	for i,v in ipairs(result) do
		total = total + v
	end
	return total
end

function checkMouseOver(objX, objY, objW, objH, mouseX, mouseY)
	local objX2 = objX + objW
	local objY2 = objY + objH
	return mouseX > objX and mouseX < objX2 and mouseY > objY and mouseY < objY2
end

function circleCollision(firstObj, secondObj, firstR, secondR)
	local dxy = distance(firstObj, secondObj)
	return firstR + secondR >= dxy
end

function foundIn(feedTable, value)
	local found = false
	for i,v in ipairs(feedTable) do
		if v == value then
		found = true
		end
	end
	return found
end

function gridPos(x,y)
	local tW = tileWidth
	local tH = tileHeight
	gridX = math.ceil((x+5)/tW)
	gridY = math.ceil((y+5)/tH)
	return gridX, gridY
end

	